CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

'' Indices for R/C receiver inputs 
  IN_THRO  = 0
  IN_AILE  = 1
  IN_ELEV  = 2
  IN_RUDD  = 3
  IN_AUX1  = 4
  IN_AUX2  = 5

  FL_MOTOR = 0
  FR_MOTOR = 1          
  BR_MOTOR = 2
  BL_MOTOR = 3
  OUT_AUX1 = 4
  OUT_AUX2 = 5

VAR

  long Thro,Aile,Elev,Rudd,AUX1,AUX2                    ' RC input variables
  long Output[8]                                        ' Used to store values that are written to ESC
  
OBJ

  RCIN     : "RC Reciever 6 Inputs"                     'Reads R/C PWM input signals.                   Requires 1 Cog. 
  ESC      : "Servo 8 Outputs"                          'Sends PWM signal to ESC's.                     Requires 1 Cog.

PUB Main
  Initiate_RCIN
  Initiate_ESC
  Repeat
    Get_RC
    Write_to_ESC

PUB Get_RC
'>>>>>>>>>>> This Section Takes 376.6uS

  Thro := RCIN.GetRC(IN_THRO)
  'Aile := RCIN.GetRC(IN_AILE)
  'Elev := RCIN.GetRC(IN_ELEV)
  'Rudd := RCIN.GetRC(IN_RUDD)
  'AUX1 := RCIN.GetRC(IN_AUX1)
  'AUX2 := RCIN.GetRC(IN_AUX2)

  Thro += 1500
  Output[0] := Output[1] := Output[2] := Output[3] := Thro
  
  
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
PUB Write_to_ESC

  ESC.Set(FL_MOTOR,Output[0])
  ESC.Set(FR_MOTOR,Output[1])
  ESC.Set(BR_MOTOR,Output[2])
  ESC.Set(BL_MOTOR,Output[3])

'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
PUB Initiate_RCIN

  RCIN.Start
  
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
PUB Initiate_ESC 

  ESC.Start
  
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>